## libcifpp 1.0.1

=== debian/changelog ===
libcifpp (1.0.1-3) unstable; urgency=medium

  * [PATCH] revision.hpp: Patch to use SOURCE_DATE_EPOCH
    Closes: #977999
  * Added French debconf translation (thanks to Jean-Pierre Giraud)
    Closes: #978533
  * Added Dutch debconf translation (thanks to Frans Spiesschaert)
    Closes: #977613

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 08:02:04 +0100

libcifpp (1.0.1-2) unstable; urgency=medium

  * Fix postrm script
  * Fix update script

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 17 Dec 2020 08:26:23 +0100

libcifpp (1.0.1-1) unstable; urgency=medium

  * Added German debconf translation (thanks to Helge Kreutzman)
    Closes: #976627
  * Add fix for 32bit environment in Symmetry code

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Dec 2020 16:07:49 +0100

libcifpp (1.0.0-3) unstable; urgency=medium

  * Added -latomic as library to remedy build issues on armel

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 27 Nov 2020 13:29:06 +0100

libcifpp (1.0.0-2) unstable; urgency=medium

  [ Maarten L. Hekkelman ]
  * Work around compile time errors on some Debian architectures
  * Use debian script to copy examples instead of patching makefile

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)
  * Add salsa-ci file (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 27 Nov 2020 10:10:59 +0100

libcifpp (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #974973)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 17 Nov 2020 10:36:02 +0100
