=== debian/control ===
Source: libcifpp
Priority: optional
Section: libs
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Maarten L. Hekkelman <maarten@hekkelman.com>,
 Andreas Tille <tille@debian.org>,
Build-Depends:
 autoconf-archive,
 debhelper-compat (= 13),
 libboost-date-time-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-system-dev,
 po-debconf,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
Homepage: https://github.com/PDB-REDO/libcifpp
Rules-Requires-Root: no

Package: libcifpp-dev
Section: libdevel
Architecture: any
Depends:
 libcifpp1 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This specific package contains all files needed to develop new
 software using libcifpp.

Package: libcifpp1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This package contains the library file only.
