=== debian/tests/control ===
Tests: run-build-test
Depends:
 build-essential,
 libcifpp-dev,
 pkg-config,
Restrictions: allow-stderr
