## libcifpp 2.0.5

=== debian/changelog ===
libcifpp (2.0.5-1build1) jammy; urgency=medium

  * No-change rebuild against libboost-regex1.74.0-icu70.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2022 16:00:31 +0100

libcifpp (2.0.5-1) unstable; urgency=medium

  * New upstream release, backporting some changes from v3.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 07 Feb 2022 11:42:22 +0100

libcifpp (2.0.4-8) unstable; urgency=medium

  * Fix configuration error, linking to std::filesystem.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Feb 2022 20:16:44 +0100

libcifpp (2.0.4-7) unstable; urgency=medium

  * Transition.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 01 Feb 2022 11:26:25 +0100

libcifpp (2.0.4-6) experimental; urgency=medium

  * Fix atomic patch. 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 31 Jan 2022 13:57:10 +0100

libcifpp (2.0.4-5) experimental; urgency=medium

  * Add cif++/Config.hpp again as stub.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 31 Jan 2022 11:32:35 +0100

libcifpp (2.0.4-4) experimental; urgency=medium

  * Fix patch for libatomic, again

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 19 Jan 2022 08:29:45 +0100

libcifpp (2.0.4-3) experimental; urgency=medium

  * Fix patch for libatomic

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 17 Jan 2022 13:53:28 +0100

libcifpp (2.0.4-2) experimental; urgency=medium

  * Add patch to build on systems that need libatomic

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 17 Jan 2022 12:31:46 +0100

libcifpp (2.0.4-1) experimental; urgency=medium

  [ Andrius Merkys ]
  * Team upload.
  * Dropping empty directory for patches.
  * Installing empty directory at /etc/libcifpp/cache-update.d for
    libcifpp-data.
  * Marking libcifpp2 with 'Multi-Arch: same'.

  [ Maarten L. Hekkelman ]
  * New upstream version, fixes compilation with g++-11.

 -- Andrius Merkys <merkys@debian.org>  Thu, 04 Nov 2021 08:23:58 -0400

libcifpp (1.0.1-5) unstable; urgency=medium

  * Team upload.
    + Source-only upload for testing migration.

 -- Nilesh Patra <nilesh@debian.org>  Sun, 31 Oct 2021 16:54:38 +0530

libcifpp (1.0.1-4) unstable; urgency=medium

  [ Maarten L. Hekkelman] 
  * Added Spanish debconf translation (thanks to Camaleón)
    Closes: #987666
  * Added Brazilian Portuguese debconf translation
    (thanks to Adriano Rafael Gomes)
    Closes: #987436
  * Added Portuguese debconf translation (thanks to Américo Monteiro)
    Closes: #982333
  * Added gcc11.patch to fix numerous build issues with the new compiler
    Closes: #984093
  
  [ Étienne Mollier ]
  * Team upload.
  * Created package libcifpp-data to separate files independent from the ABI.
    Closes: #994551

  [ Andreas Tille ]
  * Apply multi-arch hints.
    + libcifpp-dev: Add Multi-Arch: same.

  [ Étienne Mollier ]
  * Added ambiguous-conversion.patch fixing further ftbfs.
    Thanks Maarten L. Hekkelman for the hint!
  * d/copyright: pdb file now delivered under CC0

 -- Étienne Mollier <emollier@debian.org>  Fri, 29 Oct 2021 20:14:28 +0200
