=== debian/control ===
--- 
+++ 
@@ -12,7 +12,10 @@
  libboost-dev,
  libboost-iostreams-dev,
  libboost-system-dev,
+ libboost-program-options-dev,
  po-debconf,
+ cmake,
+ mrc
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
 Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
@@ -23,8 +26,9 @@
 Section: libdevel
 Architecture: any
 Depends:
- libcifpp1 (= ${binary:Version}),
+ libcifpp2 (= ${binary:Version}),
  ${misc:Depends},
+Multi-Arch: same
 Description: Development files for libcifpp
  Libcifpp is a C++ library used to create and manipulate
  mmCIF and PDB files containing macro molecular structure information.
@@ -32,13 +36,30 @@
  This specific package contains all files needed to develop new
  software using libcifpp.
 
-Package: libcifpp1
+Package: libcifpp2
 Architecture: any
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ libcifpp-data
+Multi-Arch: same
 Description: Library files for libcifpp
  Libcifpp is a C++ library used to create and manipulate
  mmCIF and PDB files containing macro molecular structure information.
  .
  This package contains the library file only.
+
+Package: libcifpp-data
+Architecture: all
+Multi-Arch: foreign
+Depends:
+ ${misc:Depends}
+Breaks:
+ libcifpp1 (<< 1.0.1-4)
+Replaces:
+ libcifpp1 (<< 1.0.1-4)
+Description: Data files for libcifpp
+ Libcifpp is a C++ library used to create and manipulate
+ mmCIF and PDB files containing macro molecular structure information.
+ .
+ This package contains the architecture independent data for the library.
