=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DCIFPP_USE_RSRC=ON -DCIFPP_BUILD_TESTS=ON -DCIFPP_INSTALL_UPDATE_SCRIPT=ON
