=== debian/tests/control ===
Tests: run-build-test
Depends:
 build-essential,
 libcifpp-dev,
 pkg-config,
 libboost-iostreams-dev,
 libboost-regex-dev
Restrictions: allow-stderr
