=== debian/changelog ===
libcifpp (5.0.7.1-3build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:50:59 +0100

libcifpp (5.0.7.1-3) unstable; urgency=medium

  * Fix compiling with gcc-13. Closes: #1037723

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 16 Jul 2023 11:31:45 +0200

libcifpp (5.0.7.1-2) unstable; urgency=medium

  * Update data update script a bit more.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 06 Feb 2023 06:53:02 +0100

libcifpp (5.0.7.1-1) unstable; urgency=medium

  * New upstream
  * Change address for data from ftp to https. Closes: #1030038

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 09:20:53 +0100

libcifpp (5.0.5-6) unstable; urgency=medium

  * Fix typo in cron script.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 03 Jan 2023 09:02:35 +0100

libcifpp (5.0.5-5) unstable; urgency=medium

  * Fix in cron script.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 02 Jan 2023 14:09:18 +0100

libcifpp (5.0.5-4) unstable; urgency=medium

  * Start transition.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 29 Dec 2022 19:51:39 +0100

libcifpp (5.0.5-3) experimental; urgency=medium

  * Added more -dev dependencies.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 24 Nov 2022 09:47:38 +0100

libcifpp (5.0.5-2) experimental; urgency=medium

  * That pesky static_assert again 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 19 Nov 2022 11:13:51 +0100

libcifpp (5.0.5-1) experimental; urgency=medium

  * Fixes for 32 bit 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 19 Nov 2022 10:29:17 +0100

libcifpp (5.0.4-2) experimental; urgency=medium

  * Remove reference to lzma
  * Remove unneeded static assert

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 18 Nov 2022 22:08:35 +0100

libcifpp (5.0.4-1) experimental; urgency=medium

  * Revert exporting CIFPP_SHARE_DIR variable
  * Remove boost::regex code and use system boost::regex instead
  * In postrm remove the correct cron script

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Nov 2022 09:09:02 +0100

libcifpp (5.0.3-1) experimental; urgency=medium

  * Team upload.
  * New upstream release 

 -- Andrius Merkys <merkys@debian.org>  Mon, 14 Nov 2022 01:50:39 -0500

libcifpp (2.0.5-4) unstable; urgency=medium

  * Disable LTO. Closes: #1015480

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 20 Jul 2022 08:57:17 +0200

libcifpp (2.0.5-3) unstable; urgency=medium

  * Version 2.0.5-2 contained an error in the closes section.
    Closes: #1012906

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jul 2022 16:25:14 +0200

libcifpp (2.0.5-2) unstable; urgency=medium

  * Include <cstring> to silence g++-12 bug
    Closes: #1012973, #1012913, #1012973, #1012983

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jul 2022 15:16:04 +0200
