=== debian/control ===
--- 
+++ 
@@ -6,16 +6,12 @@
  Maarten L. Hekkelman <maarten@hekkelman.com>,
  Andreas Tille <tille@debian.org>,
 Build-Depends:
- autoconf-archive,
  debhelper-compat (= 13),
- libboost-date-time-dev,
  libboost-dev,
- libboost-iostreams-dev,
- libboost-system-dev,
- libboost-program-options-dev,
+ libboost-regex-dev,
+ zlib1g-dev,
  po-debconf,
- cmake,
- mrc
+ cmake
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
 Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
@@ -26,7 +22,9 @@
 Section: libdevel
 Architecture: any
 Depends:
- libcifpp2 (= ${binary:Version}),
+ libcifpp5 (= ${binary:Version}),
+ libboost-regex-dev,
+ zlib1g-dev,
  ${misc:Depends},
 Multi-Arch: same
 Description: Development files for libcifpp
@@ -36,7 +34,7 @@
  This specific package contains all files needed to develop new
  software using libcifpp.
 
-Package: libcifpp2
+Package: libcifpp5
 Architecture: any
 Depends:
  ${misc:Depends},
