=== debian/tests/control ===
Tests: run-build-test
Depends:
 build-essential,
 libcifpp-dev,
 zlib1g-dev,
 pkg-config
Restrictions: allow-stderr
